/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jfxslideshowbasic;

import java.util.List;
import javafx.animation.*;
import javafx.application.Application;
import javafx.beans.property.*;
import javafx.beans.value.*;
import javafx.scene.*;
import javafx.scene.image.*;
import javafx.scene.paint.*;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 *
 * @author hussmann
 */
public class JFXSlideshowBasic extends Application {
    
    @Override
    public void start(Stage primaryStage) {
        
        Color background = Color.rgb(255,228,95);

        final Image[] imagearray = {
            new Image("file:pics/tiger.jpg", true),
            new Image("file:pics/elephant.jpg", true),
            new Image("file:pics/jbeans.jpg", true),
            new Image("file:pics/peppers.jpg", true),
            new Image("file:pics/butterfly.jpg", true),
        };
   
        final ImageView picture = new ImageView();
        picture.setX(50);
        picture.setY(50);
        picture.setImage(imagearray[0]);
        
        final IntegerProperty slideindex = new SimpleIntegerProperty();
        slideindex.addListener(new ChangeListener(){
            @Override public void changed(ObservableValue o, Object oldVal, Object newVal){
                picture.setImage(imagearray[slideindex.getValue()]);
            }
        });


        Group root = new Group(picture);
        Scene scene = new Scene(root, 356, 356, background);       
        
        Timeline timeline = new Timeline();
        List<KeyFrame> keyframes = timeline.getKeyFrames();
        for(int i=0; i<imagearray.length; i++) {
            keyframes.add(new KeyFrame(new Duration(i*4000), new KeyValue(slideindex, i)));
        }
        
        primaryStage.setTitle("Simple Slide Show with JavaFX");
        primaryStage.setScene(scene);
        primaryStage.sizeToScene();
        primaryStage.show();
        timeline.play();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
